!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module ArareSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: arareset.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!arare ¹Ԥ뤿ɬפʥѥ᥿ NAMELIST . 
!NAMELIST ̾ϳ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module arareset

  implicit none

  !--- save °
  save
                                                                 !=begin
  !== Public Interface 
  !
  real(8)  :: alpha  !ȸη
  real(8)  :: beta   !󥯥˥륽ˡʤ 0.5, ʤ 1
  real(8)  :: Cm     !ήͥ륮Ǽη 
  real(8)  :: tfil   !åλ֥ե륿η
  real(8)  :: NuH    !Ǵη (ʿ)
  real(8)  :: NuV    !Ǵη (ľ)
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NameList ե뤫 arare ¹Ԥɬפʥѥ᥿
  !
  subroutine arareset_init(cfgfile)
    !=== Dependency
    use dc_trace, only: BeginSub, EndSub 
    use gridset,  only: DelX, DelZ
    use timeset,  only: DelTimeShort, DelTimeLong
    
    !=== Input 
    character(*), intent(in) :: cfgfile
                                                                 !=end
    !--- ѿ
    real(8)  ::  AlphaH
    real(8)  ::  AlphaV
                                                                 !=begin
    !=== NAMELIST
    NAMELIST /arareset/ alpha, beta, Cm, tfil, AlphaH, AlphaV
                                                                 !=end

    call BeginSub("arareset_init", &
&                 fmt="%c",       &
&                 c1="Initialize parameters.")

    !--- ѿμФ
    open (10, FILE=cfgfile)
    read(10, NML=arareset)
    close(10)

    !--- ȸη
    alpha = alpha * ( DelX ** 2.0d0 ) / DelTimeShort

    !--- Ǵη
    NuH  = AlphaH * ( DelX ** 2.0d0 ) / DelTimeLong
    NuV  = AlphaV * ( DelZ ** 2.0d0 ) / DelTimeLong

    !==== ǧ
!    write(*,*) "alpha", alpha
!    write(*,*) "beta", beta
!    write(*,*) "Cm", Cm
!    write(*,*) "tfil", tfil
!    write(*,*) "NuH", NuH
!    write(*,*) "NuV", NuV

    call EndSub("arareset_init")
    
  end subroutine arareset_init
  
end module arareset
