!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module BasicSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: basicset.f90,v 1.2.2.1 2005/07/26 10:55:06 kitamo Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ܾͤ. 
!   * basicset_file_init: ܾͤ netCDF ե뤫
!   * basicset_calc_init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module BasicSet
  !== ۤηػ
  implicit none

  !== save °
  save
                                                                 !=begin
  !== Public Interface
  real(8), allocatable   :: ss_CpBasicZ(:,:)       !Ǯ
  real(8), allocatable   :: ss_DensBasicZ(:,:)     !̩
  real(8), allocatable   :: ss_ExnerBasicZ(:,:)    !̵
  real(8), allocatable   :: ss_PotTempBasicZ(:,:)    !
  real(8), allocatable   :: ss_VelSoundBasicZ(:,:) !®
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !ܾͤ netCDF ե뤫. 
  !netCDF ͤ뤿 gt4f90io Ѥ. 
  !
  subroutine BasicSet_file_init(basicfile)

    !=== Dependency
    use dc_trace, only: BeginSub, EndSub
    use gt4_history
    use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax

    !=== Input
    character(*), intent(in) :: basicfile
                                                                 !=end
    
    character(20)  :: name            !ѿ̾

    call BeginSub("basicset_file_init", &
&                 fmt="%c",       &
&                 c1="Get basic state variables from netCDF file.")
    
    !--- γ
    allocate(  &
         & ss_CpBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) )

                                                                 !=begin
    !=== Get a Value from netCDF File
    name = "CpBasicZ"
    call HistoryGet( basicfile, name, ss_CpBasicZ )

    name = "ExnerBasicZ"
    call HistoryGet( basicfile, name, ss_ExnerBasicZ )

    name = "PotTempBasicZ"
    call HistoryGet( basicfile, name, ss_PotTempBasicZ )

    name = "DensBasicZ"
    call HistoryGet( basicfile, name, ss_DensBasicZ )

    name = "VelSoundBasicZ"
    call HistoryGet( basicfile, name, ss_VelSoundBasicZ ) 
                                                                 !=end   

    call EndSub("basicset_file_init")

  end subroutine BasicSet_file_init


                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !ŵŪʴܾ׻뤿Υץ basic νͤ
  !ɤ߹, ܾͤ׻뤿Υ⥸塼
  !
  !ŵŪʴܾΤ׻뤿Υ֥롼. 
  !פȤƤϰʲǽ. 
  !   * ٰ or ̰
  !   * ϰ or ſ尵ʿ
  !
  subroutine basicset_calc_init(cfgfile)
    !=== Dependency
    use dc_trace,   only: BeginSub, EndSub 
    use dc_message, only: MessageNotify
    use gridset,    only: DimXMin, DimXMax, DimZMin, DimZMax, s_Z
    use physset,    only: Grav, TempSfc, PressSfc, MolWtDry, CpDry, GasRUniv
    
    !=== Input
    character(*), intent(in) :: cfgfile  !ե(NAMELIST)
                                                                 !=end
    !=== Work
    character(80) :: TempType
    character(80) :: PressType
    real(8)  :: ss_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) ! ʿѲپ
    real(8)  :: ss_CvBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)  :: ss_Z(DimXMin:DimXMax, DimZMin:DimZMax)          ! 2-D ɸ
    real(8)  :: GasR
    integer  :: k
                                                                 !=begin
    !=== NAMELIST 
    NAMELIST /basicset/ TempType, PressType
                                                                 !=end

    call BeginSub("basicset_calc_init", &
&                 fmt="%c",       &
&                 c1="calculate the basic state variables.")

    open (10, FILE=cfgfile)
    read(10, NML=basicset)
    close(10)

    !==== ǧ
!    write(*,*) "TempType",  TempType
!    write(*,*) "PressType", PressType
    

    !=== ѿν
    allocate( ss_CpBasicZ(DimXMin:DimXMax, DimZMin:DimZMax),     &
         &    ss_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax),   &
         &    ss_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax),  &
         &    ss_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
         &    ss_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) )

    ss_CpBasicZ = 0.0d0
    ss_DensBasicZ = 0.0d0
    ss_ExnerBasicZ = 0.0d0
    ss_PotTempBasicZ = 0.0d0
    ss_VelSoundBasicZ = 0.0d0

    !--- ɸ
    do k = DimZMin, DimZMax
       ss_Z(:,k) = s_Z(k)
    end do
    
    !--------------------------------------------
    !--- 
    !--------------------------------------------
    GasR = GasRUniv / MolWtDry
    
    !--------------------------------------------
    !--- Ǯ
    !---   Ǯϴ絤ǰƬ˰ͤȤ. 
    !--------------------------------------------
    ss_CpBasicZ = CpDry / MolWtDry
    ss_CvBasicZ = ss_CpBasicZ - GasR
  
    !--------------------------------------------
    !--- /, ̵Ϥδܾ
    !--------------------------------------------
    if (TempType == "uniform" .AND. PressType == "uniform") then 
       
       !--- پ TempSfc ǰ
       ss_TempBasicZ = TempSfc
       
       !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
       ss_ExnerBasicZ = 1.0d0
       
       !--- 
       ss_PotTempBasicZ = ss_TempBasicZ / ss_ExnerBasicZ 
       
    elseif (TempType == "uniform" .AND. PressType == "hydrostatic") then 
       
       !--- پ TempSfc ǰ
       ss_TempBasicZ = TempSfc
       
       !--- ̵ϤȲ̤ϢΩƲ. 
       ss_ExnerBasicZ = &
            & dexp( - Grav * ss_Z / ( ss_CpBasicZ * ss_TempBasicZ ) )

       !--- ̵ϤѤƲ̤׻
       ss_PotTempBasicZ = ss_TempBasicZ / ss_ExnerBasicZ
       
    elseif (TempType == "adiabat" .AND. PressType == "uniform") then 
       
       !--- ɽ̤Ǥβ(= TempSfc)ǰ
       ss_PotTempBasicZ = TempSfc
       
       !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
       ss_ExnerBasicZ = 1.0d0
       
    elseif (TempType == "adiabat" .AND. PressType == "hydrostatic") then 
       
       !--- ɽ̤Ǥβ(= TempSfc)ǰ
       ss_PotTempBasicZ = TempSfc
       
       !--- ̵Ϥ׻. ̰
       ss_ExnerBasicZ = &
            & - Grav * ss_Z / ( ss_CpBasicZ * ss_PotTempBasicZ ) + 1.0d0

    elseif (TempType == "odaka1998" .AND. PressType == "hydrostatic") then 
       
       do k = DimZMin, DimZMax
          if ( s_Z(k) <= 5000.0d0 ) then
             !---  245 K ǰ
             ss_PotTempBasicZ(:,k) = 245.0d0
             
             !--- ̵Ϥ׻. ̰
             ss_ExnerBasicZ(:,k) = &
                  & - Grav * ss_Z(:,k) / ( ss_CpBasicZ(:,k) * ss_PotTempBasicZ(:,k) ) + 1.0d0

          else
             !--- پ TempSfc ǰ
             ss_TempBasicZ(:,k) = 220.0d0
             
             !--- ̵ϤȲ̤ϢΩƲ. 
             ss_ExnerBasicZ(:,k) = &
                  & dexp( - Grav * ss_Z(:,k) / ( ss_CpBasicZ(:,k) * ss_TempBasicZ(:,k) ) )
             
             !--- ̵ϤѤƲ̤׻
             ss_PotTempBasicZ(:,k) = ss_TempBasicZ(:,k) / ss_ExnerBasicZ(:,k)

          end if
       end do

    else
       call MessageNotify("Message", "basicset_calc_init", &
            &             "unknown TempType, or PressType")
    end if
    
    
    !--------------------------------------------
    !---- ̩
    !--------------------------------------------
    ss_DensBasicZ = &
         & PressSfc * ( ss_ExnerBasicZ ** (ss_CvBasicZ / GasR) ) &
         &   / ( GasR * ss_PotTempBasicZ )
    
    
    !--------------------------------------------    
    !--- ʿѾβ®
    !--------------------------------------------
    ss_VelSoundBasicZ = &
         & ss_CpBasicZ * GasR * ss_ExnerBasicZ * ss_PotTempBasicZ &
         &   / ss_CvBasicZ  
    ss_VelSoundBasicZ = sqrt( ss_VelSoundBasicZ )


    !==== ǧ
!    write(*,*) "ss_CpBasicZ ", maxval( ss_CpBasicZ )
!    write(*,*) "ss_DensBasicZ ", maxval( ss_DensBasicZ )
!    write(*,*) "ss_ExnerBasicZ ", maxval( ss_ExnerBasicZ )
!    write(*,*) "ss_PotTempBasicZ ", maxval( ss_PotTempBasicZ )
!    write(*,*) "ss_VelSoundBasicZ ", maxval( ss_VelSoundBasicZ )
    

    call EndSub("basicset_calc_init")

  end subroutine basicset_calc_init
  
end module BasicSet
