!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module GridSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: gridset.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ɸѥ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

module gridset
  !--- ۤηػ
  implicit none

  !--- save °
  save
                                                                 !=begin
  !== Public Interface
  real(8)               :: Xmin, Xmax    ! x ɸλ
  real(8)               :: Zmin, Zmax    ! z ɸλ
  real(8)               :: DelX, DelZ    !ʻҴֳ
  real(8)               :: DelXZ         !ʿѳʻҴֳ(ʿѺΥ)
  integer               :: NX, NZ        !ʻ
  integer               :: DimXMin       ! x β
  integer               :: DimXMax       ! x ξ
  integer               :: DimZMin       ! z β
  integer               :: DimZMax       ! z ξ
  integer               :: RegXMin       ! x ʪΰβ
  integer               :: RegXMax       ! x ʪΰξ
  integer               :: RegZMin       ! z ʪΰβ
  integer               :: RegZMax       ! z ʪΰξ
  integer               :: FileNX        !ե
  integer               :: FileNZ        !ե
  integer               :: FileXMin      !ե
  integer               :: FileXMax      !ե
  integer               :: FileZMin      !ե
  integer               :: FileZMax      !ե
  integer, parameter    :: Margin = 5    !Υåɿ
  integer, parameter    :: kind = 8      !٤ɽ
  real(8), allocatable  :: s_X(:)        !X ɸ(顼)
  real(8), allocatable  :: f_X(:)        !X ɸ(٥ȥ)
  real(8), allocatable  :: s_Z(:)        !Z ɸ(顼)
  real(8), allocatable  :: f_Z(:)        !Z ɸ(٥ȥ)
                                                                 !=end  
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST , ʻ׻
  !
  subroutine gridset_init(cfgfile)

    !=== Dependency
    use dc_trace,  only: BeginSub, EndSub 
    use debugset,  only: DebugOn 

    !=== Input
    character(*), intent(in) :: cfgfile
                                                                 !=end    
    !=== ѿ
    integer            :: i, k
                                                                 !=begin    
    !=== NAMELIST 
    NAMELIST /gridset/ &
         & NX, NZ, Xmin, Xmax, Zmin, Zmax
                                                                 !=end

    call BeginSub("gridset_init", &
&                 fmt="%c",       &
&                 c1="Initialize grid point and interval. ")
    
    open (10, FILE=cfgfile)
    read(10, NML=gridset)
    close(10)

    !==== ʻֳַ׻
    DelX = (Xmax - Xmin) / real(NX, kind)
    DelZ = (Zmax - Zmin) / real(NZ, kind)

    !==== ʿѳʻֳ
    DelXZ = sqrt( DelX * DelZ )
    
    !==== ʪŪ˰̣Τΰξ¡¤
    RegXMin = 0
    RegXMax = NX
    RegZMin = 0
    RegZMax = NZ

    !==== ξ¡¤
    DimXMin = RegXMin - Margin
    DimXMax = RegXMax + Margin
    DimZMin = RegZMin - Margin
    DimZMax = RegZMax + Margin

    !==== åɤ
    allocate( f_X(DimXMin:DimXMax), f_Z(DimZMin:DimZMax) )
    do i = DimXMin, DimXMax
       f_X(i) = Xmin + DelX * ( real(i, kind) - RegXMin )
    end do
    do k = DimZMin, DimZMax
       f_Z(k) = Zmin + DelZ * ( real(k, kind) - RegZMin )
    end do
    
    !==== ȾʻҤ줿åɤ. ֳ֤ˤƤ.
    allocate( s_X(DimXMin: DimXMax), s_Z(DimZMin: DimZMax) )
    s_X(DimXMin+1:DimXMax) =            &
         &  (                     &
         &     f_X(DimXMin+1:DimXMax)     &
         &   + f_X(DimXMin:DimXMax-1)     &
         &  ) * 5.0d-1
    s_X(DimXMin) = s_X(DimXMin+1) - DelX
    
    s_Z(DimZMin+1:DimZMax) =             &
         &  (                     &
         &     f_Z(DimZMin+1:DimZMax)     &
         &   + f_Z(DimZMin:DimZMax-1)     &
         &  ) * 5.0d-1
    s_Z(DimZMin) = s_Z(DimZMin+1) - DelZ

    !==== ǥХå⡼ɤݤ, եϤѤѿ礭Ѥ
    if (DebugOn) then
       FileNX   = size(f_X, 1)
       FileNZ   = size(f_Z, 1)
       FileXMin = DimXMin
       FileXMax = DimXMax
       FileZMin = DimZMin
       FileZMax = DimZMax
    else
       FileNX   = NX
       FileNZ   = NZ
       FileXMin = RegXMin + 1
       FileXMax = RegXMax
       FileZMin = RegZMin + 1
       FileZMax = RegZMax
    end if
    
    !==== ǧ
!    write(*,*) "Xmin, Xmax", Xmin, Xmax
!    write(*,*) "Zmin, Zmax", Zmin, Zmax
!    write(*,*) "DelX, DelZ", DelX, DelZ
!    write(*,*) "DelXZ", DelXZ
!    write(*,*) "NX, NZ", NX, NZ
!    write(*,*) "DimXMin, DimXMax", DimXMin, DimXMax
!    write(*,*) "DimZMin, DimZMax", DimZMin, DimZMax
!    write(*,*) "RegXMin, RegXMax", RegXMin, RegXMax
!    write(*,*) "RegZMin, RegZMax", RegZMin, RegZMax
!    write(*,*) "FileNX, FileNZ", FileNX, FileNZ
!    write(*,*) "FileXMin, FileXMax", FileXMin, FileXMax
!    write(*,*) "FileZMin, FileZMax", FileZMin, FileZMax
!    write(*,*) "Margin", Margin
!    write(*,*) "kind", kind
!    write(*,*) "s_X", s_X
!    write(*,*) "f_X", f_X
!    write(*,*) "s_Z", s_Z
!    write(*,*) "f_Z", f_Z

    call EndSub("gridset_init")

  end subroutine gridset_init
  
end module gridset
