!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module LAPACK_Linear
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: lapack_linear.f90,v 1.2 2005/04/22 15:01:52 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!LAPACK ׻ΤΥѥå⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * гѹβˡǥ󥰤Ƥʤ
!
                                                                 !=end

module LAPACK_linear
  implicit none
  
  private
                                                                 !=begin
  !=== Public Interface
  public lapack_dgtsv_init  !
  public lapack_dgtsv       ! 3 ϢΩ 1 ()
  public lapack_dgttrf      ! 3  LU ʬ
  public lapack_dgttrs      !LU ʬѤμ 3 ϢΩ 1 ()
                                                                 !=end
  integer                   :: N = 10       !ͤϥߡ

  save N

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module
  !
  !LAPACK  DGTSV 롼ν
  !
  subroutine lapack_dgtsv_init(M)

    !=== Input
    integer, intent(in) :: M  !礭
                                                                 !=end
    N = M
  end subroutine lapack_dgtsv_init
  
  
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  ! 3 ϢΩ 1 ()
  !
  subroutine lapack_dgtsv(A, B, C, D)
    !=== Dependency
    use dc_message, only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none
                                                                 !=begin
    !=== In/Out
    real(8), intent(inout)         :: A(N)      !
    real(8), intent(inout)         :: B(N-1)    !
    real(8), intent(inout)         :: C(N-1)    !
    real(8), intent(inout)         :: D(1,N)    !/
                                                                 !=end
    !=== Work
    integer                        :: NRHS
    integer                        :: INFO
    integer                        :: LDB

    !=== ѿν
    NRHS = 0; INFO = 0; LDB = N
    
    !=== η׻. LAPACK . 
    call DGTSV(N, NRHS, C, A, B, D, LDB, INFO)
!    call DGTTRF(N, C, A, B, B2, IPIV, INFO)
!
!    !=== Υǥå. 
!    if (INFO /= 0) then
!       call MessageNotify("Error", "lapack_linear", &
!&                        "INFO is not 0")
!       stop
!    end if
!
!    call DGTTRS(TRANS, N, NRHS, C, A, B, B2, IPIV, D, LDB, INFO)

    !=== Υǥå. 
    if (INFO /= 0) then
       call MessageNotify("Error", "lapack_linear", &
&                        "INFO is not 0")
       stop
    end if
    
  end subroutine lapack_dgtsv


  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  ! 3 ϢΩ 1 ()
  !
  subroutine lapack_dgttrf(A, B, C, B2, IPIV)
    !=== Dependency
    use dc_message, only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none
                                                                 !=begin
    !=== In/Out
    real(8), intent(inout)         :: A(N)      !
    real(8), intent(inout)         :: B(N-1)    !
    real(8), intent(inout)         :: C(N-1)    !
    real(8), intent(out)           :: B2(N-2)   !
    real(8), intent(out)           :: IPIV(N)   !ʬԥܥåȸ򴹤ξǼ
                                                                 !=end
    !=== Work
    integer                        :: INFO

    !=== ѿν
    INFO = 0
    
    !=== η׻. LAPACK . 
    call DGTTRF(N, C, A, B, B2, IPIV, INFO)

    !=== Υǥå. 
    if (INFO /= 0) then
       call MessageNotify("Error", "lapack_linear", &
&                        "INFO is not 0")
       stop
    end if

  end subroutine lapack_dgttrf
  
  
  !== Procedure Interface 
  !
  !=== Execute Subroutine for the module
  !
  ! 3 ϢΩ 1 ()
  ! LU ʬ򤵤Ƥ
  !
  subroutine lapack_dgttrs(A, B, C, D, B2, IPIV)
    !=== Dependency
    use dc_message, only: MessageNotify
                                                                 !=end
    !=== ۤηػ
    implicit none
                                                                 !=begin
    !=== In/Out
    real(8), intent(inout)         :: A(N)      !
    real(8), intent(inout)         :: B(N-1)    !
    real(8), intent(inout)         :: C(N-1)    !
    real(8), intent(inout)         :: D(1,N)    !/
    real(8), intent(inout)         :: B2(N-2)    !
    real(8), intent(in)            :: IPIV(N)   !ʬԥܥåȸ򴹤ξǼ
                                                                 !=end
    !=== Work
    integer                        :: NRHS
    integer                        :: INFO
    integer                        :: LDB
    character(1),parameter         :: TRANS = 'N'

    !=== ѿν
    NRHS = 0; INFO = 0; LDB = N
    
    !=== η׻. LAPACK . 
    call DGTTRS(TRANS, N, NRHS, C, A, B, B2, IPIV, D, LDB, INFO)

    !=== Υǥå. 
    if (INFO /= 0) then
       call MessageNotify("Error", "lapack_linear", &
&                        "INFO is not 0")
       stop
    end if
    
  end subroutine lapack_dgttrs

end module LAPACK_linear
